package com.usky.fire.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.usky.common.core.bean.CommonPage;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.fire.domain.DemFireAccidentDesc;
import com.usky.fire.domain.DemFireStatistics;
import com.usky.fire.mapper.DemFireStatisticsMapper;
import com.usky.fire.service.DemFireStatisticsService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 火灾统计表 服务实现类
 * </p>
 *
 * @author JCB
 * @since 2022-09-13
 */
@Service
public class DemFireStatisticsServiceImpl extends AbstractCrudService<DemFireStatisticsMapper, DemFireStatistics> implements DemFireStatisticsService {

    @Override
    public CommonPage<DemFireStatistics> fireAccidentStatistic(String companyCode, String startDate, String endDate, Integer pageNum, Integer pageSize) {
        IPage<DemFireStatistics> page = new Page<>(pageNum, pageSize);
        LambdaQueryWrapper<DemFireStatistics> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.select(DemFireStatistics::getBurnedArea, DemFireStatistics::getDirectPropertyLoss, DemFireStatistics::getVictimNumber,
                DemFireStatistics::getInjuredNumber, DemFireStatistics::getDeathToll, DemFireStatistics::getFileCase, DemFireStatistics::getFireGrade,
                DemFireStatistics::getSubordinateDetachment, DemFireStatistics::getAdministrativeDivision, DemFireStatistics::getFireNumber,
                DemFireStatistics::getFireAddress, DemFireStatistics::getFireTime, DemFireStatistics::getId)
                .eq(StringUtils.isNotBlank(companyCode), DemFireStatistics::getCompanyCode, companyCode)
                .between(StringUtils.isNotBlank(startDate) & StringUtils.isNotBlank(endDate), DemFireStatistics::getFillTime, startDate, endDate)
                .orderByDesc(DemFireStatistics::getId);
        page = this.page(page, queryWrapper);
        return new CommonPage<>(page.getRecords(), page.getTotal(), pageSize, pageNum);
    }

}
